# Memorandum 开发备忘录 

* with 应该采用静态构建
* httpClient 应该性能优化下；保持单例；
* <del>广告在本地存储、使用时应该外面再包一层，以便获取更多信息，减少信息获取的层次；</del>
* CorpGangerWorker 应该返回的是一个广告列表，而不是一个广告；
* 数据不足时kotlin是如何解析的；
* 所有可能异常的地方，考虑是否埋一个点
* <del>文件读写的慢线程应该只有一个，并且要等前台重要线程完成文件等操作后才启动后台线程；</del>缓存线程完成之后才会启动第一线程；
* <del>AD是否过期还没有实现</del>已修改
* 资源的清理以广告为单位，即比广告粒度还小的事件不应该触发广告清理
* <del>本地已经有广告的情况下不应该再次请求广告资源</del>
* 可以指定线程，在没有指定线程池中的情况下，使用默认线程；注意如果线程池是单个的情况下，检查是否存在同步问题；
* 切换企业这种用例是不是没有考虑？
* <del>权限被拒绝的情况没考虑？</del>已处理
* 清理时机目前只做了一个————写入存储的时候清理
* 遇到难点了，多次调用的同步问题；




### 测试备忘
* 1、测试文件读写权限情况下的处理逻辑
* 2、测试网络不返回、网络返回没有广告等情况下的处理逻辑；
* 3、清除缓存之后需要测试一下
* 4、需要测试是否返回过期的广告、是否只获取一个广告等逻辑的是否正常
* 5、测试的时候要测试文件夹里面本身就存在乱七八糟的文件的情况；
* 6、检查一下所有的mkDirs;防止抛出文件是文件夹的异常；
* 7、两种线程回调都要试一下；

### 
* 进入时权限允许，进行到一半是不允许，这种情况不予考虑